// This file was generated by Dashcode from Apple Inc.
// You may edit this file to customize your Dashboard widget.

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
    setupParts();
	
	sync();
	
	energyUnitText();
	fatUnitText();
	portionUnitText();
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    
	// Remove any preferences as needed
	widget.setPreferenceForKey(null, "energy-unit");
	widget.setPreferenceForKey(null, "units-size");
	widget.setPreferenceForKey(null, "constants");
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
	var EnergyUnitIndex = widget.preferenceForKey("energy-unit");
	var UnitsSizeIndex = widget.preferenceForKey("units-size");
	var constantsIndex = widget.preferenceForKey("constants");

	var energy_units = document.getElementById('energyUnits');
	var units_size = document.getElementById('unitsSize');
	var consts = document.getElementById('consts');

	energy_units.selectedIndex = EnergyUnitIndex;
	units_size.selectedIndex = UnitsSizeIndex;
	consts.selectedIndex = constantsIndex;
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}


function floatOnly_key(event)
{	
    var keychar = String.fromCharCode(event.keyCode);
	
	if (keychar == ".")
	{
		var dotcheck = /\./; 
		event.returnValue = !dotcheck.test(event.srcElement.value);
	}
	else
	{
		var numcheck = /\d/;
		event.returnValue = numcheck.test(keychar);
	}

	if(event.returnValue || event.keyCode == 8 )
	{
		setTimeout(points_reclac, 5);	
	}
}


function points_reclac(event)
{
	var energy = parseFloat(document.getElementById('energy').value);
	var fat = parseFloat(document.getElementById('fat').value);
	var portion = parseFloat(document.getElementById('portion').value);
    
	var points = document.getElementById('points');

	if( isNaN(energy) || isNaN(fat) || isNaN(portion) )
	{
		points.value = "";
	}
	else
	{
		var energy_units = parseFloat(document.getElementById('energyUnits').value);
		var units_size = parseFloat(document.getElementById('unitsSize').value);
		var consts = document.getElementById('consts').value.split(';');
		var energy_const = parseFloat(consts[0]);
		var fat_const = parseFloat(consts[1]);
		
		var ptsv = (((energy*energy_units/energy_const) + (fat/fat_const))/units_size) * portion;
		var pts = Math.round(ptsv*2.0)/2.0;
		
		points.value = pts;
	}
}


function energyUnitText()
{
	var energy_unit_text = document.getElementById('energy_unit');
	var energy_units = document.getElementById('energyUnits');
	var units_size = document.getElementById('unitsSize');

	energy_unit_text.innerHTML = energy_units[energy_units.selectedIndex].text + "/" + 
		units_size[units_size.selectedIndex].text;
}

function fatUnitText()
{
	var fat_unit_text = document.getElementById('fat_unit');
	var units_size = document.getElementById('unitsSize');

	fat_unit_text.innerHTML = getLocalizedString("fat_unit") + "/" + 
		units_size[units_size.selectedIndex].text;
}

function portionUnitText()
{
	var portion_unit_text = document.getElementById('portion_unit');
	var units_size = document.getElementById('unitsSize');

	if(units_size[units_size.selectedIndex].value == "1")
	{
		portion_unit_text.innerHTML = units_size[units_size.selectedIndex].text;
	}
	else
	{
		portion_unit_text.innerHTML = getLocalizedString("fat_unit");
	}
}

function energyUnitsChanged(event)
{
	var value = document.getElementById('energyUnits').selectedIndex;
	widget.setPreferenceForKey(value, "energy-unit");

	energyUnitText();
}

function unitsSizeChanged(event)
{
	var value = document.getElementById('unitsSize').selectedIndex;
	widget.setPreferenceForKey(value, "units-size");

	energyUnitText();
	fatUnitText();  
	portionUnitText();
}


function constantsChanged(event)
{
	var value = document.getElementById('consts').selectedIndex;
	widget.setPreferenceForKey(value, "constants");    
}

function points_focus(event)
{
	var energy = document.getElementById('energy');

    energy.select();
	energy.focus();					
}

